' Started....08/12/17
' Microcontroller used:  Microchip Technology PIC16F88
'                        microchip.com
' PicBasic Pro Code: micro-Engineering Labs, Inc.
'                    melabs.com 

'--------Program Desciption--------

'If the switch on the box is open then the lid opens showing the frog that performs several routines. Each routine causes the frogs arm to close the switch and shut the lid.
' 

   #CONFIG
 __CONFIG    _CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
 #ENDCONFIG
 OSCCON = $60
'
' 
 DEFINE OSC 4  'oscillator 4MHz
                                                                                                                   
 
 
  ANSEL = %00000000  ' all digital                 
                       ' changes other analog bits to digital.
    TRISB = %10000001 ' RB0 input rest outputs                  
    TRISA = %00100000 'RA5 input rest outputs   
   CMCON = 7 'comparitors off

     
       
'------------Variables-------------
  x var byte 'number of pulses 
  y var byte
  z var byte
  a var byte 
  b var byte
  c var byte
   
'----------Initialization----------
    
    
   
   c = 1                         
   b = 1  
   a = 1
   x = 1
   y = 1
   z = 1
   PORTB.1 = 0 'Arm servo input 0
   PORTB.2 = 0 'Lid servo input 0
   
   PORTB.3 = 1 'recorder off M2
   PORTB.4 = 1 'recorder off M3
   PORTB.5 = 0 'light off
   PORTB.6 = 0 'frog sound on
   PORTA.0 = 0 'mute off
'-------------Main Code------------
   Main:
   PORTA.2 = 0 'inhibit mouth movement at start ie box lid closed
   if PORTB.0 = 0 then goto Servo
   if PORTB.0 = 1 then goto Main
   Servo:
  
   PORTB.6 = 1 'frog sound off
   PORTA.0 = 1 'mute on
  
  
   for x = 1 to 20
   PORTB.2 = 1
   
   pauseus 1000
   PORTB.2 = 0 
   pause 19
   next x  'box lid open
  PORTB.5 = 1 'light on         
   pause 50
    Arm:
   PORTB.1 = 1
   pauseus  900
   PORTB.1 = 0 
   pause 19
   if PORTB.0 = 0 then goto arm  ' if switch isn't closed then continue running servo  
   if PORTB.0 = 1 then goto Cont ' if switch is closed arm is maximum then start operation to send arm to minimum
   
   Cont:      
   pause 50
   for z = 1 to 20
    PORTB.1 = 1
   pause 2
   PORTB.1 = 0 
   pause 19
   next z ' arm servo goes to minimum
    PORTB.5 = 0'light off
   pause 50
    for a = 1 to 20
   PORTB.2 = 1
   pauseus 1980
   PORTB.2 = 0 
   pause 19
   next a         'box lid closed
  
   pause 50
   
   Main2:
   if PORTB.0 = 0  then goto  Servo2
   if PORTB.0 = 1 then goto Main2    
   Servo2:
  
    PORTB.3 = 0
   pause 200
   PORTB.3 = 1  'start player
    PORTA.2 = 1 'mouth movement on
   
    
   for x = 1 to 20
   PORTB.2 = 1
  
   pauseus 1000
   PORTB.2 = 0 
   pause 19
   next x         'box lid open
   PORTB.5 = 1   'light on
   pause 50
    Arm2:
   PORTB.1 = 1
   pauseus  900
   PORTB.1 = 0 
   pause 19
   
   
   if PORTB.0 = 0 then goto arm2  ' if switch isn't closed then continue running servo  
   if PORTB.0 = 1 then goto Cont2 ' if switch is closed arm is maximum then start operation to send arm to minimum
   
   Cont2: 
   for b = 1 to 2 
   PORTB.1 = 1
   pause 1
   PORTB.1 = 0 
   pause 19
   next b    'move arm back a few degrees
   PORTA.0 = 0 'mute off
   pause 1800  'stop operation while recorder is playing
   for z = 1 to 20
    PORTB.1 = 1
   pause 2
   PORTB.1 = 0 
   pause 19
   next z ' arm servo retracts
   pause 50
    for a = 1 to 20
   PORTB.2 = 1
   pauseus 1980
   PORTB.5 = 0  'light off
   PORTB.2 = 0 
   pause 19
   next a         'box lid closed
   pause 50
   goto Main3
   
    Main3:
   if PORTB.0 = 0 then goto Servo3
   if PORTB.0 = 1 then goto Main3
   
    
   Servo3:
    for x = 1 to 20
   PORTB.2 = 1
   pauseus 1980
  
   PORTB.2 = 0 
    PORTB.5 = 1 'light on
   pause 19
  
   next x         'box lid open
   
    for a = 1 to 20
   
   PORTB.2 = 1
   
   pauseus 1000
   PORTB.2 = 0 
   PORTB.5 = 0 'light off
   pause 19
   
   next a        'box lid closed
   c = c + 1
   if c < 4  then goto Servo3 'repeat box lid opening 3 times  
   if c = 4 then goto Player
   Player:
   PORTB.5 = 1 'light on
    PORTB.4 = 0
   pause 200
   PORTB.4 = 1  'start player
      
   Arm3:
   c = 1
  
    
   PORTB.1 = 1
   pauseus  900
   PORTB.1 = 0 
   pause 19     'arm out
   
   
   if PORTB.0 = 0 then goto arm3  ' if switch isn't closed then continue running servo  
   if PORTB.0 = 1 then goto Cont3 ' if switch is closed arm is maximum then start operation to send arm to minimum
   
   Cont3:
   
     
   for b = 1 to 2 
   PORTB.1 = 1
   pause 1
   PORTB.1 = 0 
   pause 19
   next b    'move arm back a few degrees
  
    
   
   pause 2500  'stop operation while recorder is playing
   
   for z = 1 to 20
    PORTB.1 = 1
   pause 2
   PORTB.1 = 0 
   pause 19
   next z ' arm retracts
   pause 50
   PORTB.5 = 0
    for a = 1 to 20
   PORTB.2 = 1
   pauseus 1980
   PORTB.2 = 0 
   pause 19
   next a         'box lid closed
    pause 50
    PORTB.6 = 0 'frog sound on
   goto Main
   end
   
   

	
